<?php

/***********************************/
/* Script root path */
$dir = dirname(__FILE__);
$dir = ereg_replace(".install","",$dir);
define("SCRIPT_ROOT_PATH",$dir);
/* Share directory */
define("SHARE_DIR",$dir.'/share');
/***********************************/


/***********************************/
/* Checks if public/templates_c/ is writeable */
if(!is_writable(SCRIPT_ROOT_PATH.'/public/templates_c'))
{
	echo "<h4 align='center' style='color: red;'>Please CHMOD 777 public/templates_c/ directory</h4>";
	exit();
}
/***********************************/


/***********************************/
/* configuration file and main functions */
require_once(SCRIPT_ROOT_PATH.'/class/class.config.php');
$config_manager =& MyconfigManager::getInstance();
$CONFIG =& $config_manager->getConfig();
$CONFIG['site_url'] = str_replace($file,'','http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']);
$CONFIG['site_url'] = substr($CONFIG['site_url'],0,strlen($CONFIG['site_url'] )-1);
$CONFIG['use_smartycache'] = '0';
$CONFIG['smarty_cache_lifetime'] = '3600';
require_once(SCRIPT_ROOT_PATH.'/include/common.php');
/***********************************/

/***********************************/
/* Smarty Engine */
require_once(SCRIPT_ROOT_PATH.'/class/class.templateengine.php');
$template_dir = SCRIPT_ROOT_PATH."/install/templates/";
$theme_dir = $CONFIG['site_url']."/templates";
$smarty =& TemplateEngine::getInstance();
$smarty->template_dir = $template_dir;
$smarty->assign("theme_dir",$theme_dir);
/***********************************/


/***********************************/
require_once(SCRIPT_ROOT_PATH.'/install/cookie.session.php');
$ses = new cookieSession('install');
/***********************************/


/***********************************/
/* Loading MyDirectory class*/
require_once (SCRIPT_ROOT_PATH.'/class/class.dir.php');
/***********************************/

/***********************************/
/* Language manager */
$language = isset($_GET['language']) ? $_GET['language'] : (isset($_COOKIE['language']) ? $_COOKIE['language'] : 'french');
require_once(SCRIPT_ROOT_PATH.'/class/class.languagemanager.php');
$langmanager = new LanguageManager(SCRIPT_ROOT_PATH.'/install/language/', $language, 'install.php');
$langmanager->loadLang();
/***********************************/

$smarty->clear_compiled_tpl();
?>